Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/Makefile_saprc_f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/Makefile_saprc_f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/Makefile_saprc_f90	(revision 2696)
@@ -0,0 +1,178 @@
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# User: Set here the F90 compiler and options
+#       Pedefined compilers: INTEL, PGF, HPUX, LAHEY
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#COMPILER = G95
+#COMPILER = LAHEY
+COMPILER = INTEL
+#COMPILER = PGF
+#COMPILER = HPUX
+#COMPILER = GFORTRAN
+
+FC_G95     = g95
+FOPT_G95   = -cpp -O -pg -fbounds-check -fimplicit-none  -Wall -ftrace=full
+
+FC_LAHEY   = lf95
+# More aggressive for production runs:
+#FOPT_LAHEY = -Cpp --pca -O
+# More checking for debugging:
+FOPT_LAHEY = -Cpp --chk a,e,s,u --pca --ap -O0 -g --trap --trace --chkglobal
+
+FC_INTEL   = ifort 
+# More aggressive for production runs:
+FOPT_INTEL = -cpp -O -fp-model precise -pc80 -prec_div
+# More checking for debugging:
+#FOPT_INTEL = -cpp -O0 -fp-model strict -implicitnone -ftrapuv \
+#              -debug all -check all -warn all
+
+FC_PGF     = pgf90
+# More aggressive for production runs:
+FOPT_PGF   = -Mpreprocess -O -fast -pc 80 -Kieee
+# More checking for debugging:
+#FOPT_PGF   = -Mpreprocess -O0 -Mbounds -Mchkfpstk -Mchkptr -Mchkstk \
+#             -Ktrap=fp -pc 80 -Kieee
+
+FC_HPUX    = f90
+FOPT_HPUX  = -O -u +Oall +check=on
+
+FC_GFORTRAN     = gfortran
+FOPT_GFORTRAN   = -cpp -O
+
+# define FULL_ALGEBRA for non-sparse integration
+FC   = $(FC_$(COMPILER))
+FOPT = $(FOPT_$(COMPILER)) # -DFULL_ALGEBRA
+
+LIBS =
+#LIBS = -llapack -lblas
+
+# Command to create Matlab mex gateway routines 
+# Note: use $(FC) as the mex Fortran compiler
+MEX  = mex
+
+GENSRC = saprc_f90_Precision.f90  \
+	 saprc_f90_Parameters.f90     \
+	 saprc_f90_Global.f90  
+
+GENOBJ = saprc_f90_Precision.o    \
+	 saprc_f90_Parameters.o       \
+	 saprc_f90_Global.o     
+
+FUNSRC = saprc_f90_Function.f90 
+FUNOBJ = saprc_f90_Function.o 
+
+JACSRC = saprc_f90_JacobianSP.f90  saprc_f90_Jacobian.f90
+JACOBJ = saprc_f90_JacobianSP.o    saprc_f90_Jacobian.o
+
+HESSRC = saprc_f90_HessianSP.f90   saprc_f90_Hessian.f90
+HESOBJ = saprc_f90_HessianSP.o     saprc_f90_Hessian.o
+
+STMSRC = saprc_f90_StoichiomSP.f90 saprc_f90_Stoichiom.f90 
+STMOBJ = saprc_f90_StoichiomSP.o   saprc_f90_Stoichiom.o
+
+UTLSRC = saprc_f90_Rates.f90 saprc_f90_Util.f90 saprc_f90_Monitor.f90
+UTLOBJ = saprc_f90_Rates.o   saprc_f90_Util.o   saprc_f90_Monitor.o
+
+LASRC  = saprc_f90_LinearAlgebra.f90 
+LAOBJ  = saprc_f90_LinearAlgebra.o   
+
+STOCHSRC = saprc_f90_Stochastic.f90 
+STOCHOBJ = saprc_f90_Stochastic.o 
+
+MAINSRC = saprc_f90_Main.f90   saprc_f90_Initialize.f90   saprc_f90_Integrator.f90 saprc_f90_Model.f90
+MAINOBJ = saprc_f90_Main.o     saprc_f90_Initialize.o     saprc_f90_Integrator.o   saprc_f90_Model.o 
+
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# User: modify the line below to include only the
+#       objects needed by your application
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+ALLOBJ = $(GENOBJ) $(FUNOBJ) $(JACOBJ) $(HESOBJ) $(STMOBJ) \
+	 $(UTLOBJ) $(LAOBJ)
+
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# User: modify the line below to include only the
+#       executables needed by your application
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+all:    exe
+
+exe:	$(ALLOBJ) $(MAINOBJ) 
+	$(FC) $(FOPT) $(ALLOBJ) $(MAINOBJ) $(LIBS) -o saprc_f90.exe
+
+stochastic:$(ALLOBJ) $(STOCHOBJ) $(MAINOBJ)
+	$(FC) $(FOPT) $(ALLOBJ) $(STOCHOBJ) $(MAINOBJ) $(LIBS) \
+	-o saprc_f90_stochastic.exe
+
+mex:    $(ALLOBJ)
+	$(MEX) FC#$(FC) -fortran -O saprc_f90_mex_Fun.f90     $(ALLOBJ)
+	$(MEX) FC#$(FC) -fortran -O saprc_f90_mex_Jac_SP.f90  $(ALLOBJ)
+	$(MEX) FC#$(FC) -fortran -O saprc_f90_mex_Hessian.f90 $(ALLOBJ)
+
+clean:
+	rm -f saprc_f90*.o saprc_f90*.mod \
+	saprc_f90*.dat saprc_f90.exe saprc_f90*.mexglx \
+	saprc_f90.map
+
+distclean:
+	rm -f saprc_f90*.o saprc_f90*.mod \
+	saprc_f90*.dat saprc_f90.exe saprc_f90.map \
+	saprc_f90*.f90 saprc_f90_*.mexglx
+
+saprc_f90_Precision.o: saprc_f90_Precision.f90 
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Parameters.o: saprc_f90_Parameters.f90 \
+	            saprc_f90_Precision.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Monitor.o: saprc_f90_Monitor.f90 \
+	             saprc_f90_Precision.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Global.o: saprc_f90_Global.f90 \
+	            saprc_f90_Parameters.o saprc_f90_Precision.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Initialize.o: saprc_f90_Initialize.f90  $(GENOBJ) 
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Function.o: saprc_f90_Function.f90  $(GENOBJ) 
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Stochastic.o: saprc_f90_Stochastic.f90  $(GENOBJ) 
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_JacobianSP.o: saprc_f90_JacobianSP.f90 $(GENOBJ)
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Jacobian.o: saprc_f90_Jacobian.f90  $(GENOBJ) saprc_f90_JacobianSP.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_LinearAlgebra.o: saprc_f90_LinearAlgebra.f90 $(GENOBJ) saprc_f90_JacobianSP.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Rates.o: saprc_f90_Rates.f90  $(GENOBJ) 
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_HessianSP.o: saprc_f90_HessianSP.f90  $(GENOBJ)
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Hessian.o:  saprc_f90_Hessian.f90 $(GENOBJ) saprc_f90_HessianSP.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_StoichiomSP.o: saprc_f90_StoichiomSP.f90 $(GENOBJ)
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Stoichiom.o: saprc_f90_Stoichiom.f90  $(GENOBJ) saprc_f90_StoichiomSP.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Util.o: saprc_f90_Util.f90  $(GENOBJ) saprc_f90_Monitor.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Main.o: saprc_f90_Main.f90  $(ALLOBJ) saprc_f90_Initialize.o saprc_f90_Model.o saprc_f90_Integrator.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Model.o: saprc_f90_Model.f90  $(ALLOBJ) saprc_f90_Integrator.o
+	$(FC) $(FOPT) -c $<
+
+saprc_f90_Integrator.o: saprc_f90_Integrator.f90  $(ALLOBJ)
+	$(FC) $(FOPT) -c $<
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/Small.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/Small.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/Small.kpp	(revision 2696)
@@ -0,0 +1,6 @@
+#MODEL      small_strato 
+#INTEGRATOR rosenbrock_soa 
+#LANGUAGE   Fortran90 
+#DRIVER     general_soa_check
+#HESSIAN    on
+#STOICMAT   on
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/Test.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/Test.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/Test.kpp	(revision 2696)
@@ -0,0 +1,6 @@
+#MODEL      saprcnov 
+#INTEGRATOR rosenbrock_soa 
+#LANGUAGE   Fortran90 
+#DRIVER     general_soa_check
+#HESSIAN    on
+#STOICMAT   on
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/aaa.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/aaa.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/aaa.kpp	(revision 2696)
@@ -0,0 +1,6 @@
+#MODEL      saprcnov 
+#INTEGRATOR rosenbrock_soa 
+#LANGUAGE   Fortran90 
+#DRIVER     general_soa_check
+#HESSIAN    on
+#STOICMAT   on
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/box.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/box.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/box.kpp	(revision 2696)
@@ -0,0 +1,6 @@
+#MODEL      saprc99
+#INTEGRATOR rosenbrock 
+#LANGUAGE   C 
+#DRIVER     general 
+#HESSIAN    off
+#STOICMAT   off
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/cell.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/cell.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/cell.kpp	(revision 2696)
@@ -0,0 +1,6 @@
+#MODEL      cell_cycle 
+#INTEGRATOR gillespie
+#LANGUAGE   Matlab
+#DRIVER     general_stochastic
+#STOCHASTIC on
+#STOICMAT   on
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/dsdrv6.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/dsdrv6.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/dsdrv6.f	(revision 2696)
@@ -0,0 +1,495 @@
+      program dsdrv6 
+c
+c     Program to illustrate the idea of reverse communication
+c     in Cayley mode for a generalized symmetric eigenvalue 
+c     problem.  The following program uses the two LAPACK subroutines 
+c     dgttrf.f and dgttrs.f to factor and solve a tridiagonal system of 
+c     equations.
+c
+c     We implement example six of ex-sym.doc in DOCUMENTS directory
+c
+c\Example-6
+c     ... Suppose we want to solve A*x = lambda*M*x in inverse mode,
+c         where A and M are obtained by the finite element of the
+c         1-dimensional discrete Laplacian
+c                             d^2u / dx^2
+c         on the interval [0,1] with zero Dirichlet boundary condition
+c         using piecewise linear elements.
+c
+c     ... OP = (inv[A-sigma*M])*(A+sigma*M)  and  B = M.
+c
+c     ... Use mode 5 of DSAUPD.
+c
+c\BeginLib
+c
+c\References:
+c  1. R.G. Grimes, J.G. Lewis and H.D. Simon, "A Shifted Block Lanczos 
+c     Algorithm for Solving Sparse Symmetric Generalized Eigenproblems", 
+c     SIAM J. Matr. Anal. Apps.,  January (1993).
+c
+c\Routines called:
+c     dsaupd  ARPACK reverse communication interface routine.
+c     dseupd  ARPACK routine that returns Ritz values and (optionally)
+c             Ritz vectors.
+c     dgttrf  LAPACK tridiagonal factorization routine.
+c     dgttrs  LAPACK tridiagonal solve routine.
+c     daxpy   Level 1 BLAS that computes y <- alpha*x+y.
+c     dcopy   Level 1 BLAS that copies one vector to another.
+c     dscal   Level 1 BLAS that scales a vector by a scalar.
+c     dnrm2   Level 1 BLAS that computes the norm of a vector. 
+c     av      Matrix vector multiplication routine that computes A*x.
+c     mv      Matrix vector multiplication routine that computes M*x.
+c
+c\Author
+c     Danny Sorensen
+c     Richard Lehoucq
+c     Chao Yang
+c     Dept. of Computational &
+c     Applied Mathematics
+c     Rice University 
+c     Houston, Texas 
+c 
+c\SCCS Information: @(#)
+c FILE: sdrv6.F   SID: 2.5   DATE OF SID: 10/17/00   RELEASE: 2
+c
+c\Remarks
+c     1. None
+c
+c\EndLib
+c------------------------------------------------------------------------
+c
+c     %-----------------------------%
+c     | Define leading dimensions   |
+c     | for all arrays.             |
+c     | MAXN:   Maximum dimension   |
+c     |         of the A allowed.   |
+c     | MAXNEV: Maximum NEV allowed |
+c     | MAXNCV: Maximum NCV allowed |
+c     %-----------------------------%
+c
+      integer          maxn, maxnev, maxncv, ldv
+      parameter        (maxn=256, maxnev=10, maxncv=25, 
+     &                 ldv=maxn)
+c
+c     %--------------%
+c     | Local Arrays |
+c     %--------------%
+c
+      Double precision
+     &                 v(ldv,maxncv), workl(maxncv*(maxncv+8)),
+     &                 workd(3*maxn), d(maxncv,2), resid(maxn), 
+     &                 ad(maxn), adl(maxn), adu(maxn), adu2(maxn),
+     &                 temp(maxn), ax(maxn), mx(maxn)
+      logical          select(maxncv)
+      integer          iparam(11), ipntr(11), ipiv(maxn)
+c
+c     %---------------%
+c     | Local Scalars |
+c     %---------------%
+c
+      character        bmat*1, which*2
+      integer          ido, n, nev, ncv, lworkl, info, j, ierr,
+     &                 nconv, maxitr, ishfts, mode
+      logical          rvec
+      Double precision
+     &                 sigma, r1, r2, tol, h
+c
+c     %------------%
+c     | Parameters |
+c     %------------%
+c
+      Double precision
+     &                 zero, one, two, four, six
+      parameter        (zero = 0.0D+0, one = 1.0D+0, 
+     &                  four = 4.0D+0, six = 6.0D+0,
+     &                  two = 2.0D+0 ) 
+c
+c     %-----------------------------%
+c     | BLAS & LAPACK routines used |
+c     %-----------------------------%
+c
+      Double precision
+     &                 dnrm2
+      external         daxpy, dcopy, dscal, dnrm2, dgttrf, dgttrs
+c
+c     %--------------------%
+c     | Intrinsic function |
+c     %--------------------%
+c
+      intrinsic        abs
+c
+c     %-----------------------%
+c     | Executable statements |
+c     %-----------------------%
+c
+c     %--------------------------------------------------%
+c     | The number N is the dimension of the matrix. A   |
+c     | generalized eigenvalue problem is solved (BMAT = |
+c     | 'G'.) NEV is the number of eigenvalues to be     |
+c     | approximated.  Since the Cayley mode is used,    |
+c     | WHICH is set to 'LM'.  The user can modify NEV,  |
+c     | NCV, SIGMA to solve problems of different sizes, |
+c     | and to get different parts of the spectrum.      |
+c     | However, The following conditions must be        |
+c     | satisfied:                                       |
+c     |                 N <= MAXN,                       | 
+c     |               NEV <= MAXNEV,                     |
+c     |           NEV + 1 <= NCV <= MAXNCV               | 
+c     %--------------------------------------------------%
+c
+      n = 100
+      nev = 4
+      ncv = 20
+      if ( n .gt. maxn ) then
+         print *, ' ERROR with _SDRV6: N is greater than MAXN '
+         go to 9000
+      else if ( nev .gt. maxnev ) then
+         print *, ' ERROR with _SDRV6: NEV is greater than MAXNEV '
+         go to 9000
+      else if ( ncv .gt. maxncv ) then
+         print *, ' ERROR with _SDRV6: NCV is greater than MAXNCV '
+         go to 9000
+      end if
+      bmat = 'G'
+      which = 'LM'
+      sigma = 1.5D+2
+c
+c     %--------------------------------------------------%
+c     | The work array WORKL is used in DSAUPD as        |
+c     | workspace.  Its dimension LWORKL is set as       |
+c     | illustrated below.  The parameter TOL determines |
+c     | the stopping criterion.  If TOL<=0, machine      |
+c     | precision is used.  The variable IDO is used for |
+c     | reverse communication and is initially set to 0. |
+c     | Setting INFO=0 indicates that a random vector is |
+c     | generated in DSAUPD to start the Arnoldi         |
+c     | iteration.                                       |
+c     %--------------------------------------------------%
+c
+      lworkl = ncv*(ncv+8)
+      tol = zero
+      ido = 0
+      info = 0
+c
+c     %---------------------------------------------------%
+c     | This program uses exact shifts with respect to    |
+c     | the current Hessenberg matrix (IPARAM(1) = 1).    |
+c     | IPARAM(3) specifies the maximum number of Arnoldi |
+c     | iterations allowed.  Mode 5 specified in the      |
+c     | documentation of DSAUPD is used (IPARAM(7) = 5).  |
+c     | All these options may be changed by the user. For |
+c     | details, see the documentation in DSAUPD.         |
+c     %---------------------------------------------------%
+c
+      ishfts = 1
+      maxitr = 300
+      mode   = 5
+c
+      iparam(1) = ishfts
+      iparam(3) = maxitr 
+      iparam(7) = mode 
+c
+c     %------------------------------------------------------%
+c     | Call LAPACK routine to factor (A-sigma*M).  The      |
+c     | stiffness matrix A is the 1-d discrete Laplacian.    |
+c     | The mass matrix M is the associated mass matrix      |
+c     | arising from using piecewise linear finite elements  |
+c     | on the interval [0, 1].                              |
+c     %------------------------------------------------------%
+c
+      h = one / dble(n+1)
+      r1 = (four / six) * h
+      r2 = (one / six) * h
+      do 20 j=1,n
+         ad(j) = two / h - sigma * r1
+         adl(j) = -one / h - sigma * r2
+ 20   continue 
+      call dcopy (n, adl, 1, adu, 1)
+      call dgttrf (n, adl, ad, adu, adu2, ipiv, ierr)
+      if (ierr .ne. 0) then 
+         print *, ' '
+         print *, ' Error with _gttrf in _SDRV6.'
+         print *, ' '
+         go to 9000
+      end if
+c
+c     %-------------------------------------------%
+c     | M A I N   L O O P (Reverse communication) |
+c     %-------------------------------------------%
+c
+ 10   continue
+c
+c        %---------------------------------------------%
+c        | Repeatedly call the routine DSAUPD and take |
+c        | actions indicated by parameter IDO until    |
+c        | either convergence is indicated or maxitr   |
+c        | has been exceeded.                          |
+c        %---------------------------------------------%
+c
+         call dsaupd ( ido, bmat, n, which, nev, tol, resid, ncv, 
+     &                 v, ldv, iparam, ipntr, workd, workl, lworkl, 
+     &                 info )
+c
+         if (ido .eq. -1) then
+c
+c           %-------------------------------------------------------%
+c           | Perform  y <--- OP*x = (inv[A-SIGMA*M])*(A+SIGMA*M)*x |
+c           | to force starting vector into the range of OP.  The   |
+c           | user should provide his/her matrix vector (A*x, M*x)  |
+c           | multiplication routines and a linear system solver    |
+c           | here.  The matrix vector multiplication routine takes |
+c           | workd(ipntr(1)) as the input vector.  The final       |
+c           | result is returned to workd(ipntr(2)).                | 
+c           %-------------------------------------------------------%
+c
+            call av (n, workd(ipntr(1)), workd(ipntr(2)))
+            call mv (n, workd(ipntr(1)), temp)
+            call daxpy(n, sigma, temp, 1, workd(ipntr(2)), 1) 
+c
+            call dgttrs ('Notranspose', n, 1, adl, ad, adu, adu2, ipiv, 
+     &                workd(ipntr(2)), n, ierr)
+            if (ierr .ne. 0) then 
+               print *, ' '
+               print *, ' Error with _gttrs in _SDRV6.'
+               print *, ' ' 
+               go to 9000
+            end if
+c
+c           %-----------------------------------------%
+c           | L O O P   B A C K to call DSAUPD again. |
+c           %-----------------------------------------%
+c
+            go to 10
+c
+         else if (ido .eq. 1) then
+c
+c           %----------------------------------------------------%
+c           | Perform y <-- OP*x = inv[A-SIGMA*M]*(A+SIGMA*M)*x. |
+c           | M*x has been saved in workd(ipntr(3)).  The user   |
+c           | need the matrix vector multiplication (A*x)        |
+c           | routine and a linear system solver here.  The      |
+c           | matrix vector multiplication routine takes         |
+c           | workd(ipntr(1)) as the input, and the result is    |
+c           | combined with workd(ipntr(3)) to form the input    |
+c           | for the linear system solver.  The final result is |
+c           | returned to workd(ipntr(2)).                       | 
+c           %----------------------------------------------------%
+c
+            call av (n, workd(ipntr(1)), workd(ipntr(2)))
+            call daxpy(n, sigma, workd(ipntr(3)), 1, workd(ipntr(2)), 1)
+            call dgttrs ('Notranspose', n, 1, adl, ad, adu, adu2, ipiv, 
+     &                   workd(ipntr(2)), n, ierr)
+            if (ierr .ne. 0) then 
+               print *, ' ' 
+               print *, ' Error with _gttrs in _SDRV6. '
+               print *, ' '
+               go to 9000
+            end if
+c
+c           %-----------------------------------------%
+c           | L O O P   B A C K to call DSAUPD again. |
+c           %-----------------------------------------%
+c
+            go to 10
+c
+         else if (ido .eq. 2) then
+c
+c           %--------------------------------------------%
+c           |             Perform  y <--- M*x.           |
+c           | Need matrix vector multiplication routine  |
+c           | here that takes workd(ipntr(1)) as input   |
+c           | and returns the result to workd(ipntr(2)). |
+c           %--------------------------------------------%
+c
+            call mv (n, workd(ipntr(1)), workd(ipntr(2)))
+c
+c           %-----------------------------------------%
+c           | L O O P   B A C K to call DSAUPD again. |
+c           %-----------------------------------------%
+c
+            go to 10
+c
+         end if 
+c
+c     %-----------------------------------------%
+c     | Either we have convergence, or there is |
+c     | an error.                               |
+c     %-----------------------------------------%
+c
+      if ( info .lt. 0 ) then
+c
+c        %--------------------------%
+c        | Error message, check the |
+c        | documentation in DSAUPD  |
+c        %--------------------------%
+c
+           print *, ' '
+           print *, ' Error with _saupd, info = ',info
+           print *, ' Check the documentation of _saupd. '
+           print *, ' '
+c
+      else 
+c
+c        %-------------------------------------------%
+c        | No fatal errors occurred.                 |
+c        | Post-Process using DSEUPD.                |
+c        |                                           |
+c        | Computed eigenvalues may be extracted.    |
+c        |                                           |
+c        | Eigenvectors may also be computed now if  |
+c        | desired.  (indicated by rvec = .true.)    |
+c        %-------------------------------------------%
+c
+         rvec = .true.
+c
+         call dseupd ( rvec, 'All', select, d, v, ldv, sigma, 
+     &        bmat, n, which, nev, tol, resid, ncv, v, ldv, 
+     &        iparam, ipntr, workd, workl, lworkl, ierr )
+c
+c        %----------------------------------------------%
+c        | Eigenvalues are returned in the first column |
+c        | of the two dimensional array D and the       |
+c        | corresponding eigenvectors are returned in   |
+c        | the first NEV columns of the two dimensional |
+c        | array V if requested.  Otherwise, an         |
+c        | orthogonal basis for the invariant subspace  |
+c        | corresponding to the eigenvalues in D is     |
+c        | returned in V.                               |
+c        %----------------------------------------------%
+c
+         if ( ierr .ne. 0 ) then 
+c
+c           %------------------------------------%
+c           | Error condition:                   |
+c           | Check the documentation of DSEUPD. |
+c           %------------------------------------%
+c
+            print *, ' '
+            print *, ' Error with _seupd, info = ', ierr
+            print *, ' Check the documentation of _seupd '
+            print *, ' '
+c
+         else
+c
+c           %---------------------------%
+c           | Compute the residual norm |
+c           |                           |
+c           |   ||  A*x - lambda*x ||   |
+c           |                           |
+c           | for the NCONV accurately  |
+c           | computed eigenvalues and  |
+c           | eigenvectors.  (iparam(5) |
+c           | indicates how many are    |
+c           | accurate to the requested |
+c           | tolerance)                |
+c           %---------------------------%
+c  
+            nconv = iparam(5)
+            do 30 j=1, nconv
+               call av(n, v(1,j), ax)
+               call mv(n, v(1,j), mx)
+               call daxpy (n, -d(j,1), mx, 1, ax, 1)
+               d(j,2) = dnrm2(n, ax, 1)
+               d(j,2) = d(j,2) / abs(d(j,1))
+ 30         continue
+c
+            call dmout(6, nconv, 2, d, maxncv, -6,
+     &           'Ritz values and relative residuals')
+c
+         end if
+c
+c        %------------------------------------------%
+c        | Print additional convergence information |
+c        %------------------------------------------%
+c
+         if ( info .eq. 1) then
+            print *, ' '
+            print *, ' Maximum number of iterations reached.'
+            print *, ' '
+         else if ( info .eq. 3) then
+            print *, ' '
+            print *, ' No shifts could be applied during implicit',
+     &               ' Arnoldi update, try increasing NCV.'
+            print *, ' '
+         end if
+c
+         print *, ' '
+         print *, ' _SDRV6 '
+         print *, ' ====== '
+         print *, ' '
+         print *, ' Size of the matrix is', n
+         print *, ' The number of Ritz values requested is', nev
+         print *, ' The number of Arnoldi vectors generated',
+     &            ' (NCV) is ', ncv
+         print *, ' What portion of the spectrum: ', which
+         print *, ' The number of converged Ritz values is ',
+     &              nconv 
+         print *, ' The number of Implicit Arnoldi update',
+     &           ' iterations taken is', iparam(3)
+         print *, ' The number of OP*x is ', iparam(9)
+         print *, ' The convergence criterion is ', tol
+         print *, ' '
+c
+      end if
+c
+c     %---------------------------%
+c     | Done with program dsdrv6. |
+c     %---------------------------%
+c
+ 9000 continue
+c
+      end
+c
+c------------------------------------------------------------------------
+c     Matrix vector subroutine
+c     where the matrix used is the 1 dimensional mass matrix
+c     arising from using the piecewise linear finite element
+c     on the interval [0,1].
+c
+      subroutine mv (n, v, w)
+      integer           n, j
+      Double precision 
+     &                  v(n), w(n), one, four, six, h
+      parameter         (one = 1.0D+0, four = 4.0D+0, 
+     &                   six = 6.0D+0) 
+c
+      w(1) =  four*v(1) + v(2)
+      do 100 j = 2,n-1
+         w(j) = v(j-1) + four*v(j) + v(j+1) 
+  100 continue
+      j = n
+      w(j) = v(j-1) + four*v(j) 
+c
+c     Scale the vector w by h.
+c
+      h = one / (six*dble(n+1))
+      call dscal(n, h, w, 1)
+      return
+      end
+c
+c------------------------------------------------------------------------
+c     Matrix vector subroutine
+c     where the matrix is the stiffness matrix obtained from the 
+c     finite element discretization of the 1-dimensional discrete Laplacian
+c     on the interval [0,1] with zero Dirichlet boundary condition
+c     using piecewise linear elements.
+c
+      subroutine av (n, v, w)
+      integer           n, j
+      Double precision
+     &                  v(n), w(n), one, two, h
+      parameter         (one = 1.0D+0, two = 2.0D+0)
+c
+      w(1) =  two*v(1) - v(2)
+      do 100 j = 2,n-1
+         w(j) = - v(j-1) + two*v(j) - v(j+1) 
+  100 continue
+      j = n
+      w(j) = - v(j-1) + two*v(j)
+c     
+c     Scale the vector w by (1/h).
+c
+      h = one / dble(n+1)
+      call dscal(n, one/h, w, 1) 
+      return
+      end
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/example.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/example.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/example.f	(revision 2696)
@@ -0,0 +1,112 @@
+      program example
+c
+      integer          lwork, n
+      parameter        (n = 100)
+      double complex   zwork(200 000), alpha(20), beta(20), 
+     $                 eivec(n,20), tmp(n), residu(n)
+c
+      integer          kmax, jmax, jmin, maxstep, method, m, l, maxnmv, 
+     $                 order, testspace, j
+      double precision tol, lock, dznrm2
+      logical          wanted
+      double complex   target
+      real             elapse
+      real             etime, tarray(2)
+c
+      target = (31.,0.0)
+      tol = 1.d-9
+      kmax = 5
+      jmax = 20
+      jmin = 10
+      maxstep = 1000
+      lock = 1.d-9
+c...     order =  0: nearest to target
+c...     order = -1: smallest real part
+c...     order =  1: largest real part
+c...     order = -2: smallest complex part
+c...     order =  2: largest complex part
+      order = 0
+c...     method = 1: gmres(m)
+c...     method = 2: cgstab(l)
+      method = 2
+c...     for gmres(m):
+      m = 30
+c...     for cgstab(l):
+      l= 2
+c...     maximum number of matvecs in cgstab or gmres
+      maxnmv = 100
+      testspace = 3
+c...     Testspace 1: w = "Standard Petrov" * v (Section 3.1.1)
+c...     Testspace 2: w = "Standard 'variable' Petrov" * v (Section 3.1.2)
+c...     Testspace 3: w = "Harmonic Petrov" * v (Section 3.5.1)
+c
+      if ( method .eq. 1 ) then
+         lwork =  4 +  m  + 5*jmax + 3*kmax
+      else
+         lwork = 10 + 6*l + 5*jmax + 3*kmax
+      end if
+      wanted = .true.
+c
+      call jdqz(alpha, beta, eivec, wanted, n, target, tol, 
+     $     kmax, jmax, jmin,
+     $     method, m, l, maxnmv, maxstep,
+     $     lock, order, testspace, zwork, lwork )
+c
+      elapse = etime( tarray )
+c
+c...     Compute the norms of the residuals:
+      do j = 1, kmax
+         call amul  ( n, eivec(1,j), residu )
+         call zscal ( n, beta(j), residu, 1)
+         call bmul  ( n, eivec(1,j), tmp )
+         call zaxpy( n, -alpha(j), tmp, 1, residu, 1 )
+         print '("lambda(",i2,"): (",1p,e11.4,",",e11.4,
+     $        " )")', j,alpha(j)/beta(j)
+         print '(a30,d13.6)', '||beta Ax - alpha Bx||:',
+     $          dznrm2( n, residu, 1 )
+      end do
+      write(*,10) tarray(1), elapse
+c
+   10 format(1x,'END JDQZ AFTER ',f6.2,' SEC. CPU-TIME AND ', f6.2,
+     $       ' SEC. ELAPSED TIME' )
+      end
+
+      subroutine PRECON( neq, q )
+c...............................................
+c...     Subroutine to compute q = K^-1 q
+c...............................................
+      integer        neq, i
+      double complex q(neq)
+c
+      do i = 1, neq
+         q(i) = i*q(i)/(i*i-31)
+      end do
+c
+      end
+c
+      subroutine AMUL( neq, q, r )
+c...............................................
+c...     Subroutine to compute r = Aq
+c...............................................
+      integer        neq, i
+      double complex q(neq), r(neq)
+c
+      do i = 1, neq
+	 r(i) = i*q(i)
+      end do
+c
+      end
+c
+      subroutine BMUL( neq, q, r )
+c...............................................
+c...     Subroutine to compute r = Bq
+c...............................................
+      integer        neq, i
+      double complex q(neq), r(neq)
+c
+      do i = 1, neq
+	 r(i) = q(i)/i
+      end do
+c
+      end
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/hsv.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/hsv.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/hsv.kpp	(revision 2696)
@@ -0,0 +1,6 @@
+#MODEL      saprcnov 
+#INTEGRATOR rosenbrock_soa 
+#LANGUAGE   Fortran90 
+#DRIVER     general_hsv
+#HESSIAN    on
+#STOICMAT   on
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/radau90.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/radau90.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/radau90.kpp	(revision 2696)
@@ -0,0 +1,6 @@
+#MODEL      saprc99
+#INTEGRATOR radau5 
+#LANGUAGE   Fortran90
+#DRIVER     general 
+#HESSIAN    on
+#STOICMAT   on
